"""autogenerated by genmsg_py from DoorsDetectorCloudRequest.msg. Do not edit."""
import roslib.message
import struct

import sensor_msgs.msg
import geometry_msgs.msg
import roslib.msg
import door_msgs.msg

class DoorsDetectorCloudRequest(roslib.message.Message):
  _md5sum = "46b5580ee042093a9a5254367bb8a4ee"
  _type = "door_handle_detector/DoorsDetectorCloudRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """door_msgs/Door door
sensor_msgs/PointCloud cloud

================================================================================
MSG: door_msgs/Door
Header header
geometry_msgs/Point32 frame_p1  ## position of the door frame
geometry_msgs/Point32 frame_p2  ## position of the door frame
geometry_msgs/Point32 door_p1   ## Ground plane projection of a point on the plane of the door 
geometry_msgs/Point32 door_p2   ## Ground plane projection of a point on the plane of the door
geometry_msgs/Point32 handle    ## Position of the door handle
float32 height               ## Height of the door

int32 UNKNOWN=0

int32 HINGE_P1=1
int32 HINGE_P2=2
int32 hinge                  

int32 ROT_DIR_CLOCKWISE=1
int32 ROT_DIR_COUNTERCLOCKWISE=2
int32 rot_dir                

int32 LOCKED=1
int32 LATCHED=2
int32 UNLATCHED=3
int32 latch_state            

geometry_msgs/Vector3 travel_dir           ## vector pointing in the direction the robot is going to travel through the door
float32 weight               ## @Sachin: what do we use this for?



================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: sensor_msgs/PointCloud
#This message holds a collection of 3d points, plus optional additional information about each point.
#Each Point32 should be interpreted as a 3d point in the frame given in the header

Header header
geometry_msgs/Point32[] points  #Array of 3d points
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point

================================================================================
MSG: sensor_msgs/ChannelFloat32
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point

string name       #channel name should give semantics of the channel (e.g. "intensity" instead of "value")
float32[] values  #values array should have same number of elements as the associated PointCloud

"""
  __slots__ = ['door','cloud']
  _slot_types = ['door_msgs/Door','sensor_msgs/PointCloud']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       door,cloud
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(DoorsDetectorCloudRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.door is None:
        self.door = door_msgs.msg.Door()
      if self.cloud is None:
        self.cloud = sensor_msgs.msg.PointCloud()
    else:
      self.door = door_msgs.msg.Door()
      self.cloud = sensor_msgs.msg.PointCloud()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.door.header.seq, _x.door.header.stamp.secs, _x.door.header.stamp.nsecs))
      _x = self.door.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_16f3i3df3I.pack(_x.door.frame_p1.x, _x.door.frame_p1.y, _x.door.frame_p1.z, _x.door.frame_p2.x, _x.door.frame_p2.y, _x.door.frame_p2.z, _x.door.door_p1.x, _x.door.door_p1.y, _x.door.door_p1.z, _x.door.door_p2.x, _x.door.door_p2.y, _x.door.door_p2.z, _x.door.handle.x, _x.door.handle.y, _x.door.handle.z, _x.door.height, _x.door.hinge, _x.door.rot_dir, _x.door.latch_state, _x.door.travel_dir.x, _x.door.travel_dir.y, _x.door.travel_dir.z, _x.door.weight, _x.cloud.header.seq, _x.cloud.header.stamp.secs, _x.cloud.header.stamp.nsecs))
      _x = self.cloud.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.cloud.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.cloud.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.cloud.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cloud.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.values))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.door is None:
        self.door = door_msgs.msg.Door()
      if self.cloud is None:
        self.cloud = sensor_msgs.msg.PointCloud()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.door.header.seq, _x.door.header.stamp.secs, _x.door.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.door.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 116
      (_x.door.frame_p1.x, _x.door.frame_p1.y, _x.door.frame_p1.z, _x.door.frame_p2.x, _x.door.frame_p2.y, _x.door.frame_p2.z, _x.door.door_p1.x, _x.door.door_p1.y, _x.door.door_p1.z, _x.door.door_p2.x, _x.door.door_p2.y, _x.door.door_p2.z, _x.door.handle.x, _x.door.handle.y, _x.door.handle.z, _x.door.height, _x.door.hinge, _x.door.rot_dir, _x.door.latch_state, _x.door.travel_dir.x, _x.door.travel_dir.y, _x.door.travel_dir.z, _x.door.weight, _x.cloud.header.seq, _x.cloud.header.stamp.secs, _x.cloud.header.stamp.nsecs,) = _struct_16f3i3df3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.cloud.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cloud.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.cloud.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cloud.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = struct.unpack(pattern, str[start:end])
        self.cloud.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.door.header.seq, _x.door.header.stamp.secs, _x.door.header.stamp.nsecs))
      _x = self.door.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_16f3i3df3I.pack(_x.door.frame_p1.x, _x.door.frame_p1.y, _x.door.frame_p1.z, _x.door.frame_p2.x, _x.door.frame_p2.y, _x.door.frame_p2.z, _x.door.door_p1.x, _x.door.door_p1.y, _x.door.door_p1.z, _x.door.door_p2.x, _x.door.door_p2.y, _x.door.door_p2.z, _x.door.handle.x, _x.door.handle.y, _x.door.handle.z, _x.door.height, _x.door.hinge, _x.door.rot_dir, _x.door.latch_state, _x.door.travel_dir.x, _x.door.travel_dir.y, _x.door.travel_dir.z, _x.door.weight, _x.cloud.header.seq, _x.cloud.header.stamp.secs, _x.cloud.header.stamp.nsecs))
      _x = self.cloud.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.cloud.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.cloud.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.cloud.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cloud.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.values.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.door is None:
        self.door = door_msgs.msg.Door()
      if self.cloud is None:
        self.cloud = sensor_msgs.msg.PointCloud()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.door.header.seq, _x.door.header.stamp.secs, _x.door.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.door.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 116
      (_x.door.frame_p1.x, _x.door.frame_p1.y, _x.door.frame_p1.z, _x.door.frame_p2.x, _x.door.frame_p2.y, _x.door.frame_p2.z, _x.door.door_p1.x, _x.door.door_p1.y, _x.door.door_p1.z, _x.door.door_p2.x, _x.door.door_p2.y, _x.door.door_p2.z, _x.door.handle.x, _x.door.handle.y, _x.door.handle.z, _x.door.height, _x.door.hinge, _x.door.rot_dir, _x.door.latch_state, _x.door.travel_dir.x, _x.door.travel_dir.y, _x.door.travel_dir.z, _x.door.weight, _x.cloud.header.seq, _x.cloud.header.stamp.secs, _x.cloud.header.stamp.nsecs,) = _struct_16f3i3df3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.cloud.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cloud.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.cloud.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cloud.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.cloud.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_16f3i3df3I = struct.Struct("<16f3i3df3I")
_struct_3f = struct.Struct("<3f")
"""autogenerated by genmsg_py from DoorsDetectorCloudResponse.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import door_msgs.msg

class DoorsDetectorCloudResponse(roslib.message.Message):
  _md5sum = "814c1a77e8c0b7c5b3832dabceff607d"
  _type = "door_handle_detector/DoorsDetectorCloudResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """door_msgs/Door[] doors


================================================================================
MSG: door_msgs/Door
Header header
geometry_msgs/Point32 frame_p1  ## position of the door frame
geometry_msgs/Point32 frame_p2  ## position of the door frame
geometry_msgs/Point32 door_p1   ## Ground plane projection of a point on the plane of the door 
geometry_msgs/Point32 door_p2   ## Ground plane projection of a point on the plane of the door
geometry_msgs/Point32 handle    ## Position of the door handle
float32 height               ## Height of the door

int32 UNKNOWN=0

int32 HINGE_P1=1
int32 HINGE_P2=2
int32 hinge                  

int32 ROT_DIR_CLOCKWISE=1
int32 ROT_DIR_COUNTERCLOCKWISE=2
int32 rot_dir                

int32 LOCKED=1
int32 LATCHED=2
int32 UNLATCHED=3
int32 latch_state            

geometry_msgs/Vector3 travel_dir           ## vector pointing in the direction the robot is going to travel through the door
float32 weight               ## @Sachin: what do we use this for?



================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['doors']
  _slot_types = ['door_msgs/Door[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       doors
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(DoorsDetectorCloudResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.doors is None:
        self.doors = []
    else:
      self.doors = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      length = len(self.doors)
      buff.write(_struct_I.pack(length))
      for val1 in self.doors:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v3 = val1.frame_p1
        _x = _v3
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v4 = val1.frame_p2
        _x = _v4
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v5 = val1.door_p1
        _x = _v5
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v6 = val1.door_p2
        _x = _v6
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v7 = val1.handle
        _x = _v7
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_f3i.pack(_x.height, _x.hinge, _x.rot_dir, _x.latch_state))
        _v8 = val1.travel_dir
        _x = _v8
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_f.pack(val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.doors = []
      for i in xrange(0, length):
        val1 = door_msgs.msg.Door()
        _v9 = val1.header
        start = end
        end += 4
        (_v9.seq,) = _struct_I.unpack(str[start:end])
        _v10 = _v9.stamp
        _x = _v10
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v9.frame_id = str[start:end]
        _v11 = val1.frame_p1
        _x = _v11
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v12 = val1.frame_p2
        _x = _v12
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v13 = val1.door_p1
        _x = _v13
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v14 = val1.door_p2
        _x = _v14
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v15 = val1.handle
        _x = _v15
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.height, _x.hinge, _x.rot_dir, _x.latch_state,) = _struct_f3i.unpack(str[start:end])
        _v16 = val1.travel_dir
        _x = _v16
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (val1.weight,) = _struct_f.unpack(str[start:end])
        self.doors.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      length = len(self.doors)
      buff.write(_struct_I.pack(length))
      for val1 in self.doors:
        _v17 = val1.header
        buff.write(_struct_I.pack(_v17.seq))
        _v18 = _v17.stamp
        _x = _v18
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v17.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v19 = val1.frame_p1
        _x = _v19
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v20 = val1.frame_p2
        _x = _v20
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v21 = val1.door_p1
        _x = _v21
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v22 = val1.door_p2
        _x = _v22
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v23 = val1.handle
        _x = _v23
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_f3i.pack(_x.height, _x.hinge, _x.rot_dir, _x.latch_state))
        _v24 = val1.travel_dir
        _x = _v24
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        buff.write(_struct_f.pack(val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.doors = []
      for i in xrange(0, length):
        val1 = door_msgs.msg.Door()
        _v25 = val1.header
        start = end
        end += 4
        (_v25.seq,) = _struct_I.unpack(str[start:end])
        _v26 = _v25.stamp
        _x = _v26
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v25.frame_id = str[start:end]
        _v27 = val1.frame_p1
        _x = _v27
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v28 = val1.frame_p2
        _x = _v28
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v29 = val1.door_p1
        _x = _v29
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v30 = val1.door_p2
        _x = _v30
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v31 = val1.handle
        _x = _v31
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.height, _x.hinge, _x.rot_dir, _x.latch_state,) = _struct_f3i.unpack(str[start:end])
        _v32 = val1.travel_dir
        _x = _v32
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (val1.weight,) = _struct_f.unpack(str[start:end])
        self.doors.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_f = struct.Struct("<f")
_struct_f3i = struct.Struct("<f3i")
_struct_3f = struct.Struct("<3f")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
class DoorsDetectorCloud(roslib.message.ServiceDefinition):
  _type          = 'door_handle_detector/DoorsDetectorCloud'
  _md5sum = '0dadc6e3af89de943ea049368f297d58'
  _request_class  = DoorsDetectorCloudRequest
  _response_class = DoorsDetectorCloudResponse
