"""autogenerated by genmsg_py from Door.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class Door(roslib.message.Message):
  _md5sum = "19464ad3b8e608fe8e2ff8a6ec098603"
  _type = "door_msgs/Door"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
geometry_msgs/Point32 frame_p1  ## position of the door frame
geometry_msgs/Point32 frame_p2  ## position of the door frame
geometry_msgs/Point32 door_p1   ## Ground plane projection of a point on the plane of the door 
geometry_msgs/Point32 door_p2   ## Ground plane projection of a point on the plane of the door
geometry_msgs/Point32 handle    ## Position of the door handle
float32 height               ## Height of the door

int32 UNKNOWN=0

int32 HINGE_P1=1
int32 HINGE_P2=2
int32 hinge                  

int32 ROT_DIR_CLOCKWISE=1
int32 ROT_DIR_COUNTERCLOCKWISE=2
int32 rot_dir                

int32 LOCKED=1
int32 LATCHED=2
int32 UNLATCHED=3
int32 latch_state            

geometry_msgs/Vector3 travel_dir           ## vector pointing in the direction the robot is going to travel through the door
float32 weight               ## @Sachin: what do we use this for?



================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  # Pseudo-constants
  UNKNOWN = 0
  HINGE_P1 = 1
  HINGE_P2 = 2
  ROT_DIR_CLOCKWISE = 1
  ROT_DIR_COUNTERCLOCKWISE = 2
  LOCKED = 1
  LATCHED = 2
  UNLATCHED = 3

  __slots__ = ['header','frame_p1','frame_p2','door_p1','door_p2','handle','height','hinge','rot_dir','latch_state','travel_dir','weight']
  _slot_types = ['Header','geometry_msgs/Point32','geometry_msgs/Point32','geometry_msgs/Point32','geometry_msgs/Point32','geometry_msgs/Point32','float32','int32','int32','int32','geometry_msgs/Vector3','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,frame_p1,frame_p2,door_p1,door_p2,handle,height,hinge,rot_dir,latch_state,travel_dir,weight
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(Door, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.frame_p1 is None:
        self.frame_p1 = geometry_msgs.msg.Point32()
      if self.frame_p2 is None:
        self.frame_p2 = geometry_msgs.msg.Point32()
      if self.door_p1 is None:
        self.door_p1 = geometry_msgs.msg.Point32()
      if self.door_p2 is None:
        self.door_p2 = geometry_msgs.msg.Point32()
      if self.handle is None:
        self.handle = geometry_msgs.msg.Point32()
      if self.height is None:
        self.height = 0.
      if self.hinge is None:
        self.hinge = 0
      if self.rot_dir is None:
        self.rot_dir = 0
      if self.latch_state is None:
        self.latch_state = 0
      if self.travel_dir is None:
        self.travel_dir = geometry_msgs.msg.Vector3()
      if self.weight is None:
        self.weight = 0.
    else:
      self.header = roslib.msg._Header.Header()
      self.frame_p1 = geometry_msgs.msg.Point32()
      self.frame_p2 = geometry_msgs.msg.Point32()
      self.door_p1 = geometry_msgs.msg.Point32()
      self.door_p2 = geometry_msgs.msg.Point32()
      self.handle = geometry_msgs.msg.Point32()
      self.height = 0.
      self.hinge = 0
      self.rot_dir = 0
      self.latch_state = 0
      self.travel_dir = geometry_msgs.msg.Vector3()
      self.weight = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_16f3i3df.pack(_x.frame_p1.x, _x.frame_p1.y, _x.frame_p1.z, _x.frame_p2.x, _x.frame_p2.y, _x.frame_p2.z, _x.door_p1.x, _x.door_p1.y, _x.door_p1.z, _x.door_p2.x, _x.door_p2.y, _x.door_p2.z, _x.handle.x, _x.handle.y, _x.handle.z, _x.height, _x.hinge, _x.rot_dir, _x.latch_state, _x.travel_dir.x, _x.travel_dir.y, _x.travel_dir.z, _x.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.frame_p1 is None:
        self.frame_p1 = geometry_msgs.msg.Point32()
      if self.frame_p2 is None:
        self.frame_p2 = geometry_msgs.msg.Point32()
      if self.door_p1 is None:
        self.door_p1 = geometry_msgs.msg.Point32()
      if self.door_p2 is None:
        self.door_p2 = geometry_msgs.msg.Point32()
      if self.handle is None:
        self.handle = geometry_msgs.msg.Point32()
      if self.travel_dir is None:
        self.travel_dir = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 104
      (_x.frame_p1.x, _x.frame_p1.y, _x.frame_p1.z, _x.frame_p2.x, _x.frame_p2.y, _x.frame_p2.z, _x.door_p1.x, _x.door_p1.y, _x.door_p1.z, _x.door_p2.x, _x.door_p2.y, _x.door_p2.z, _x.handle.x, _x.handle.y, _x.handle.z, _x.height, _x.hinge, _x.rot_dir, _x.latch_state, _x.travel_dir.x, _x.travel_dir.y, _x.travel_dir.z, _x.weight,) = _struct_16f3i3df.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_16f3i3df.pack(_x.frame_p1.x, _x.frame_p1.y, _x.frame_p1.z, _x.frame_p2.x, _x.frame_p2.y, _x.frame_p2.z, _x.door_p1.x, _x.door_p1.y, _x.door_p1.z, _x.door_p2.x, _x.door_p2.y, _x.door_p2.z, _x.handle.x, _x.handle.y, _x.handle.z, _x.height, _x.hinge, _x.rot_dir, _x.latch_state, _x.travel_dir.x, _x.travel_dir.y, _x.travel_dir.z, _x.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.frame_p1 is None:
        self.frame_p1 = geometry_msgs.msg.Point32()
      if self.frame_p2 is None:
        self.frame_p2 = geometry_msgs.msg.Point32()
      if self.door_p1 is None:
        self.door_p1 = geometry_msgs.msg.Point32()
      if self.door_p2 is None:
        self.door_p2 = geometry_msgs.msg.Point32()
      if self.handle is None:
        self.handle = geometry_msgs.msg.Point32()
      if self.travel_dir is None:
        self.travel_dir = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 104
      (_x.frame_p1.x, _x.frame_p1.y, _x.frame_p1.z, _x.frame_p2.x, _x.frame_p2.y, _x.frame_p2.z, _x.door_p1.x, _x.door_p1.y, _x.door_p1.z, _x.door_p2.x, _x.door_p2.y, _x.door_p2.z, _x.handle.x, _x.handle.y, _x.handle.z, _x.height, _x.hinge, _x.rot_dir, _x.latch_state, _x.travel_dir.x, _x.travel_dir.y, _x.travel_dir.z, _x.weight,) = _struct_16f3i3df.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_16f3i3df = struct.Struct("<16f3i3df")
